part of 'collection_value.dart';

mixin _ImmutableIterableMixin<E, S extends Iterable<E>> on _CollectionValue<S>
    implements Iterable<E> {
  @override
  bool any(bool Function(E element) test) => _base.any(test);

  @override
  Iterable<R> cast<R>() => _base.cast();

  @override
  bool contains(Object element) => _base.contains(element);

  @override
  E elementAt(int index) => _base.elementAt(index);

  @override
  bool every(bool Function(E element) test) => _base.every(test);

  @override
  Iterable<T> expand<T>(Iterable<T> Function(E element) f) => _base.expand(f);

  @override
  E get first => _base.first;

  @override
  E firstWhere(bool Function(E element) test, {E Function() orElse}) =>
      _base.firstWhere(test, orElse: orElse);

  @override
  T fold<T>(T initialValue, T Function(T previousValue, E element) combine) =>
      _base.fold(initialValue, combine);

  @override
  Iterable<E> followedBy(Iterable<E> other) => _base.followedBy(other);

  @override
  void forEach(void Function(E element) f) => _base.forEach(f);

  @override
  bool get isEmpty => _base.isEmpty;

  @override
  bool get isNotEmpty => _base.isNotEmpty;

  @override
  Iterator<E> get iterator => _base.iterator;

  @override
  String join([String separator = '']) => _base.join(separator);

  @override
  E get last => _base.last;

  @override
  E lastWhere(bool Function(E element) test, {E Function() orElse}) =>
      _base.lastWhere(test, orElse: orElse);

  @override
  int get length => _base.length;

  @override
  Iterable<T> map<T>(T Function(E e) f) => _base.map(f);

  @override
  E reduce(E Function(E value, E element) combine) => _base.reduce(combine);

  @override
  E get single => _base.single;

  @override
  E singleWhere(bool Function(E element) test, {E Function() orElse}) =>
      _base.singleWhere(test, orElse: orElse);

  @override
  Iterable<E> skip(int count) => _base.skip(count);

  @override
  Iterable<E> skipWhile(bool Function(E value) test) => _base.skipWhile(test);

  @override
  Iterable<E> take(int count) => _base.take(count);

  @override
  Iterable<E> takeWhile(bool Function(E value) test) => _base.takeWhile(test);

  @override
  List<E> toList({bool growable = true}) => _base.toList();

  @override
  Set<E> toSet() => _base.toSet();

  @override
  Iterable<E> where(bool Function(E element) test) => _base.where(test);

  @override
  Iterable<T> whereType<T>() => _base.whereType();
}
